#!/usr/bin/perl -w
# NAME: gentidyrel.pl
# AIM: *** VERY SPECIFIC *** Do all the steps to generate a release
# 1: Get last date in the verhist.log
use strict;
use warnings;
use File::Basename;  # split path ($name,$dir,$ext) = fileparse($file [, qr/\.[^.]*/] )
use Cwd;
my $os = $^O;
my $perl_dir = '/home/geoff/bin';
my $PATH_SEP = '/';
my $temp_dir = '/tmp';
if ($os =~ /win/i) {
    $perl_dir = 'C:\GTools\perl';
    $temp_dir = $perl_dir;
    $PATH_SEP = "\\";
}
unshift(@INC, $perl_dir);
require 'lib_utils.pl' or die "Unable to load 'lib_utils.pl' Check paths in \@INC...\n";
# log file stuff
our ($LF);
my $pgmname = $0;
if ($pgmname =~ /(\\|\/)/) {
    my @tmpsp = split(/(\\|\/)/,$pgmname);
    $pgmname = $tmpsp[-1];
}
my $outfile = $temp_dir.$PATH_SEP."temp.$pgmname.txt";
open_log($outfile);

# user variables
my $VERS = "0.0.5 2015-01-09";
my $load_log = 0;
my $in_release = '';
my $verbosity = 0;
my $out_file = '';

my $tidy_dir = 'F:\Projects\tidy-html5';
my $bin_dir = 'F:\Projects\tidy-bins\binaries';

# ### DEBUG ###
my $debug_on = 1;
my $def_file = '4.9.35';

### program variables
my @warnings = ();
my $cwd = cwd();

sub VERB1() { return $verbosity >= 1; }
sub VERB2() { return $verbosity >= 2; }
sub VERB5() { return $verbosity >= 5; }
sub VERB9() { return $verbosity >= 9; }

sub show_warnings($) {
    my ($val) = @_;
    if (@warnings) {
        prt( "\nGot ".scalar @warnings." WARNINGS...\n" );
        foreach my $itm (@warnings) {
           prt("$itm\n");
        }
        prt("\n");
    } else {
        prt( "\nNo warnings issued.\n\n" ) if (VERB9());
    }
}

sub pgm_exit($$) {
    my ($val,$msg) = @_;
    if (length($msg)) {
        $msg .= "\n" if (!($msg =~ /\n$/));
        prt($msg);
    }
    show_warnings($val);
    close_log($outfile,$load_log);
    exit($val);
}


sub prtw($) {
   my ($tx) = shift;
   $tx =~ s/\n$//;
   prt("$tx\n");
   push(@warnings,$tx);
}

sub process_in_file($) {
    my ($inf) = @_;
    if (! open INF, "<$inf") {
        pgm_exit(1,"ERROR: Unable to open file [$inf]\n"); 
    }
    my @lines = <INF>;
    close INF;
    my $lncnt = scalar @lines;
    prt("Processing $lncnt lines, from [$inf]...\n");
    my ($line,$inc,$lnn);
    $lnn = 0;
    foreach $line (@lines) {
        chomp $line;
        $lnn++;
        if ($line =~ /\s*#\s*include\s+(.+)$/) {
            $inc = $1;
            prt("$lnn: $inc\n");
        }
    }
}

my %days = (
    'Mon' => 1,
    'Tue' => 2,
    'Wed' => 3,
    'Thu' => 4,
    'Fri' => 5,
    'Sat' => 6,
    'Sun' => 7
    );

my %months = (
    'Jan' => 1,
    'Feb' => 2,
    'Mar' => 3,
    'Apr' => 4,
    'May' => 5,
    'Jun' => 6,
    'Jul' => 7,
    'Aug' => 8,
    'Sep' => 9,
    'Oct' => 10,
    'Nov' => 11,
    'Dec' => 12
    );

sub check_valid() {
    if (! -d $tidy_dir) {
        pgm_exit(1,"ERROR: Tidy directory $tidy_dir does NOT exist!\n"); 
    }
    my $inf = $tidy_dir . $PATH_SEP . "verhist.log";
    my $tmpv = $tidy_dir . $PATH_SEP . "tempv-".$in_release.".log";
    my $tmpdir = $bin_dir . $PATH_SEP . "tidy-$in_release";
    my $tmphtml = $tmpdir . $PATH_SEP . "$in_release.html";
    my $tmp32 = $tidy_dir . $PATH_SEP . 'build\cmake';
    my $tmp64 = $tidy_dir . $PATH_SEP . 'build\win64';
    if (! open INF, "<$inf") {
        pgm_exit(1,"ERROR: Unable to open file [$inf]\n"); 
    }
    my @lines = <INF>;
    close INF;
    my $lncnt = scalar @lines;
    prt("Processing $lncnt lines, from [$inf]...\n");
    my ($line,$inc,$lnn,@arr,$tmp,$cnt,$i);
    $lnn = 0;
    my $date = '';
    foreach $line (@lines) {
        chomp $line;
        $lnn++;
        next if ($line =~ /^\#/);
        if ($line =~ /^\d+\.\d+\.\d+.*\s+/) {
            prt("$lnn: $line\n");
            @arr = split(/\s+/,$line);
            $cnt = scalar @arr;
            for ($i = 0; $i < $cnt; $i++) {
                $tmp = $arr[$i];
                if (defined $days{$tmp}) {
                    $date = $tmp;
                    #prt("Day: $date\n");
                    $i++;
                    if ($i < $cnt) {
                        for (; $i < $cnt; $i++) {
                            $date .= ' ';
                            $date .= $arr[$i];
                        }
                    } else {
                        $date = '';
                    }
                    last;
                }
            }
            last;
        } else {
            pgm_exit(1,"ERROR: line does not start with version [$line]\n"); 
        }
    }
    if (length($date)) {
        prt("Date: $date\n");
        chdir($tidy_dir) or pgm_exit(1,"Unable to change to $tidy_dir diectory!\n");
        #  8. Get the changes since the last release `$ git log "--decorate=full" "--since=Sat Apr 25 19:20:16 2015 +0200" > ..tempvXX2.log
        if (-f $tmpv) {
            unlink "$tmpv";
        }
        system("git log \"--decorate=full\" \"--since=$date\" > $tmpv");
        if (-f $tmpv) {
            prt("Got file $tmpv\n");
            if (! -d $tmpdir) {
                mkdir $tmpdir;
            }
            if (! -d $tmpdir) {
                pgm_exit(1,"ERROR: Failed to create dir $tmpdir\n"); 
            }
            if (-f $tmphtml) {
                unlink $tmphtml;
            }
            system("emailobs -a $in_release -o $tmphtml -i $tmpv");
            if (! -f $tmphtml) {
                pgm_exit(1,"ERROR: Failed to create file $tmphtml\n"); 

            }
            chdir($tmp32) or pgm_exit(1,"Unable to change to $tmp32 diectory!\n");
            system( "build-bins.bat" );
            system( "pub-bins NOPAUSE" );
            chdir($tmp64) or pgm_exit(1,"Unable to change to $tmp64 diectory!\n");
            system( "build-bins.bat" );
            system( "pub-bins NOPAUSE" );

        } else {
            pgm_exit(1,"ERROR: Did not create file [$tmpv]\n"); 
        }
    } else {
        pgm_exit(1,"ERROR: Did not find DATE in [$line]\n"); 
    }
}

#########################################
### MAIN ###
parse_args(@ARGV);
check_valid();
# process_in_file($in_release);
pgm_exit(0,"");
########################################

sub need_arg {
    my ($arg,@av) = @_;
    pgm_exit(1,"ERROR: [$arg] must have a following argument!\n") if (!@av);
}

sub parse_args {
    my (@av) = @_;
    my ($arg,$sarg);
    my $verb = VERB2();
    while (@av) {
        $arg = $av[0];
        if ($arg =~ /^-/) {
            $sarg = substr($arg,1);
            $sarg = substr($sarg,1) while ($sarg =~ /^-/);
            if (($sarg =~ /^h/i)||($sarg eq '?')) {
                give_help();
                pgm_exit(0,"Help exit(0)");
            } elsif ($sarg =~ /^v/) {
                if ($sarg =~ /^v.*(\d+)$/) {
                    $verbosity = $1;
                } else {
                    while ($sarg =~ /^v/) {
                        $verbosity++;
                        $sarg = substr($sarg,1);
                    }
                }
                $verb = VERB2();
                prt("Verbosity = $verbosity\n") if ($verb);
            } elsif ($sarg =~ /^l/) {
                if ($sarg =~ /^ll/) {
                    $load_log = 2;
                } else {
                    $load_log = 1;
                }
                prt("Set to load log at end. ($load_log)\n") if ($verb);
            } elsif ($sarg =~ /^o/) {
                need_arg(@av);
                shift @av;
                $sarg = $av[0];
                $out_file = $sarg;
                prt("Set out file to [$out_file].\n") if ($verb);
            } else {
                pgm_exit(1,"ERROR: Invalid argument [$arg]! Try -?\n");
            }
        } else {
            $in_release = $arg;
            prt("Set input to [$in_release]\n") if ($verb);
        }
        shift @av;
    }

    if ($debug_on) {
        prtw("WARNING: DEBUG is ON!\n");
        if (length($in_release) ==  0) {
            $in_release = $def_file;
            prt("Set DEFAULT input to [$in_release]\n");
        }
    }
    if (length($in_release) ==  0) {
        pgm_exit(1,"ERROR: No version found in command!\n");
    }
    #if (! -f $in_release) {
    #    pgm_exit(1,"ERROR: Unable to find in file [$in_release]! Check name, location...\n");
    #
}

sub give_help {
    prt("$pgmname: version $VERS\n");
    prt("Usage: $pgmname [options] release-number\n");
    prt("Options:\n");
    prt(" --help  (-h or -?) = This help, and exit 0.\n");
    prt(" --verb[n]     (-v) = Bump [or set] verbosity. def=$verbosity\n");
    prt(" --load        (-l) = Load LOG at end. ($outfile)\n");
    ###prt(" --out <file>  (-o) = Write output to this file.\n");
}

# eof - template.pl
